radeonsi: rename desc_list_byte_size -> vb_desc_list_alloc_size
[mesa.git] / .gitlab-ci / deqp-runner.sh
1 #!/bin/sh
2
3 set -ex
4
5 DEQP_OPTIONS="--deqp-surface-width=256 --deqp-surface-height=256"
6 DEQP_OPTIONS="$DEQP_OPTIONS --deqp-surface-type=pbuffer"
7 DEQP_OPTIONS="$DEQP_OPTIONS --deqp-gl-config-name=rgba8888d24s8ms0"
8 DEQP_OPTIONS="$DEQP_OPTIONS --deqp-visibility=hidden"
9
10 # It would be nice to be able to enable the watchdog, so that hangs in a test
11 # don't need to wait the full hour for the run to time out. However, some
12 # shaders end up taking long enough to compile
13 # (dEQP-GLES31.functional.ubo.random.all_per_block_buffers.20 for example)
14 # that they'll sporadically trigger the watchdog.
15 #DEQP_OPTIONS="$DEQP_OPTIONS --deqp-watchdog=enable"
16
17 if [ -z "$DEQP_VER" ]; then
18 echo 'DEQP_VER must be set to something like "gles2", "gles31" or "vk" for the test run'
19 exit 1
20 fi
21
22 if [ "$DEQP_VER" = "vk" ]; then
23 if [ -z "$VK_DRIVER" ]; then
24 echo 'VK_DRIVER must be to something like "radeon" or "intel" for the test run'
25 exit 1
26 fi
27 fi
28
29 if [ -z "$DEQP_SKIPS" ]; then
30 echo 'DEQP_SKIPS must be set to something like "deqp-default-skips.txt"'
31 exit 1
32 fi
33
34 ARTIFACTS=`pwd`/artifacts
35
36 # Set up the driver environment.
37 export LD_LIBRARY_PATH=`pwd`/install/lib/
38 export EGL_PLATFORM=surfaceless
39 export VK_ICD_FILENAMES=`pwd`/install/share/vulkan/icd.d/"$VK_DRIVER"_icd.x86_64.json
40
41 # the runner was failing to look for libkms in /usr/local/lib for some reason
42 # I never figured out.
43 export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/usr/local/lib
44
45 RESULTS=`pwd`/results
46 mkdir -p $RESULTS
47
48 # Generate test case list file.
49 if [ "$DEQP_VER" = "vk" ]; then
50 cp /deqp/mustpass/vk-master.txt /tmp/case-list.txt
51 DEQP=/deqp/external/vulkancts/modules/vulkan/deqp-vk
52 else
53 cp /deqp/mustpass/$DEQP_VER-master.txt /tmp/case-list.txt
54 DEQP=/deqp/modules/$DEQP_VER/deqp-$DEQP_VER
55 fi
56
57 # If the job is parallel, take the corresponding fraction of the caselist.
58 # Note: N~M is a gnu sed extension to match every nth line (first line is #1).
59 if [ -n "$CI_NODE_INDEX" ]; then
60 sed -ni $CI_NODE_INDEX~$CI_NODE_TOTAL"p" /tmp/case-list.txt
61 fi
62
63 if [ ! -s /tmp/case-list.txt ]; then
64 echo "Caselist generation failed"
65 exit 1
66 fi
67
68 if [ -n "$DEQP_EXPECTED_FAILS" ]; then
69 XFAIL="--xfail-list $ARTIFACTS/$DEQP_EXPECTED_FAILS"
70 fi
71
72 set +e
73
74 run_cts() {
75 deqp=$1
76 caselist=$2
77 output=$3
78 deqp-runner \
79 --deqp $deqp \
80 --output $output \
81 --caselist $caselist \
82 --exclude-list $ARTIFACTS/$DEQP_SKIPS \
83 $XFAIL \
84 --job ${DEQP_PARALLEL:-1} \
85 --allow-flakes true \
86 $DEQP_RUNNER_OPTIONS \
87 -- \
88 $DEQP_OPTIONS
89 }
90
91 report_flakes() {
92 if [ -z "$FLAKES_CHANNEL" ]; then
93 return 0
94 fi
95 flakes=$1
96 bot="$CI_RUNNER_DESCRIPTION-$CI_PIPELINE_ID"
97 channel="$FLAKES_CHANNEL"
98 (
99 echo NICK $bot
100 echo USER $bot unused unused :Gitlab CI Notifier
101 sleep 10
102 echo "JOIN $channel"
103 sleep 1
104 desc="Flakes detected in job: $CI_JOB_URL on $CI_RUNNER_DESCRIPTION"
105 if [ -n "CI_MERGE_REQUEST_SOURCE_BRANCH_NAME" ]; then
106 desc="$desc on branch $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME ($CI_MERGE_REQUEST_TITLE)"
107 fi
108 echo "PRIVMSG $channel :$desc"
109 for flake in `cat $flakes`; do
110 echo "PRIVMSG $channel :$flake"
111 done
112 echo "PRIVMSG $channel :See $CI_JOB_URL/artifacts/browse/results/"
113 echo "QUIT"
114 ) | nc irc.freenode.net 6667 > /dev/null
115
116 }
117
118 extract_xml_result() {
119 testcase=$1
120 shift 1
121 qpas=$*
122 start="#beginTestCaseResult $testcase"
123 for qpa in $qpas; do
124 while IFS= read -r line; do
125 if [ "$line" = "$start" ]; then
126 dst="$testcase.qpa"
127 echo "#beginSession" > $dst
128 echo $line >> $dst
129 while IFS= read -r line; do
130 if [ "$line" = "#endTestCaseResult" ]; then
131 echo $line >> $dst
132 echo "#endSession" >> $dst
133 /deqp/executor/testlog-to-xml $dst "$RESULTS/$testcase.xml"
134 # copy the stylesheets here so they only end up in artifacts
135 # if we have one or more result xml in artifacts
136 cp /deqp/testlog.{css,xsl} "$RESULTS/"
137 return 0
138 fi
139 echo $line >> $dst
140 done
141 return 1
142 fi
143 done < $qpa
144 done
145 }
146
147 extract_xml_results() {
148 qpas=$*
149 while IFS= read -r testcase; do
150 testcase=${testcase%,*}
151 extract_xml_result $testcase $qpas
152 done
153 }
154
155 # Generate junit results
156 generate_junit() {
157 results=$1
158 echo "<?xml version=\"1.0\" encoding=\"utf-8\"?>"
159 echo "<testsuites>"
160 echo "<testsuite name=\"$DEQP_VER-$CI_NODE_INDEX\">"
161 while read line; do
162 testcase=${line%,*}
163 result=${line#*,}
164 # avoid counting Skip's in the # of tests:
165 if [ "$result" = "Skip" ]; then
166 continue;
167 fi
168 echo "<testcase name=\"$testcase\">"
169 if [ "$result" != "Pass" ]; then
170 echo "<failure type=\"$result\">"
171 echo "$result: See $CI_JOB_URL/artifacts/results/$testcase.xml"
172 echo "</failure>"
173 fi
174 echo "</testcase>"
175 done < $results
176 echo "</testsuite>"
177 echo "</testsuites>"
178 }
179
180 # wrapper to supress +x to avoid spamming the log
181 quiet() {
182 set +x
183 "$@"
184 set -x
185 }
186
187 run_cts $DEQP /tmp/case-list.txt $RESULTS/cts-runner-results.txt
188 DEQP_EXITCODE=$?
189
190 quiet generate_junit $RESULTS/cts-runner-results.txt > $RESULTS/results.xml
191
192 if [ $DEQP_EXITCODE -ne 0 ]; then
193 # preserve caselist files in case of failures:
194 cp /tmp/deqp_runner.*.txt $RESULTS/
195 echo "Some unexpected results found (see cts-runner-results.txt in artifacts for full results):"
196 cat $RESULTS/cts-runner-results.txt | \
197 grep -v ",Pass" | \
198 grep -v ",Skip" | \
199 grep -v ",ExpectedFail" > \
200 $RESULTS/cts-runner-unexpected-results.txt
201 head -n 50 $RESULTS/cts-runner-unexpected-results.txt
202
203 if [ -z "$DEQP_NO_SAVE_RESULTS" ]; then
204 # Save the logs for up to the first 50 unexpected results:
205 head -n 50 $RESULTS/cts-runner-unexpected-results.txt | quiet extract_xml_results /tmp/*.qpa
206 fi
207
208 count=`cat $RESULTS/cts-runner-unexpected-results.txt | wc -l`
209
210 # Re-run fails to detect flakes. But use a small threshold, if
211 # something was fundamentally broken, we don't want to re-run
212 # the entire caselist
213 else
214 cat $RESULTS/cts-runner-results.txt | \
215 grep ",Flake" > \
216 $RESULTS/cts-runner-flakes.txt
217
218 count=`cat $RESULTS/cts-runner-flakes.txt | wc -l`
219 if [ $count -gt 0 ]; then
220 echo "Some flakes found (see cts-runner-flakes.txt in artifacts for full results):"
221 head -n 50 $RESULTS/cts-runner-flakes.txt
222
223 if [ -z "$DEQP_NO_SAVE_RESULTS" ]; then
224 # Save the logs for up to the first 50 flakes:
225 head -n 50 $RESULTS/cts-runner-flakes.txt | quiet extract_xml_results /tmp/*.qpa
226 fi
227
228 # Report the flakes to IRC channel for monitoring (if configured):
229 quiet report_flakes $RESULTS/cts-runner-flakes.txt
230 else
231 # no flakes, so clean-up:
232 rm $RESULTS/cts-runner-flakes.txt
233 fi
234 fi
235
236 exit $DEQP_EXITCODE